﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMChart():
    """
      Provides access to members that control chart properties.
    """
    name = str()
    series = []
    generalProperties = 'CIMChartGeneralProperties'
    legend = 'CIMChartLegend'
    axes = []
    mapSelectionHandling = ChartMapSelectionHandling.Highlight
    metaData = str()
    multiSeriesChartProperties = 'CIMMultiSeriesChartProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartAxis():
    """
      Provides access to members that control chart axis properties.
    """
    visible = True
    isLogarithmic = False
    title = str()
    showTitle = True
    useAutomaticTitle = True
    valueFormat = str()
    valueNumberFormat = 'CIMNumberFormat'
    dateTimeFormat = str()
    calculateAutomaticMinimum = True
    calculateAutomaticMaximum = True
    minimum = object()
    maximum = object()
    titleText = 'CIMChartTextProperties'
    labelText = 'CIMChartTextProperties'
    axisLineSymbolProperties = 'CIMChartLineSymbolProperties'
    guides = []
    labelCharacterLimit = 11
    navigationScaleFactor = 1.0
    navigationPosition = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartFillSymbolProperties():
    """
      Provides access to members that control properties of the fill
        /// symbol.
    """
    color = 'CIMColor'
    opacity = 0
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartGeneralProperties():
    """
      Provides access to members that control general chart properties.
    """
    title = str()
    showTitle = True
    useAutomaticTitle = True
    subTitle = str()
    showSubTitle = True
    footer = str()
    showFooter = True
    theme = str()
    titleText = 'CIMChartTextProperties'
    subTitleText = 'CIMChartTextProperties'
    footerText = 'CIMChartTextProperties'
    backgroundSymbolProperties = 'CIMChartFillSymbolProperties'
    gridLineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartGuide():
    """
      Define the properties to define a chart guide.
    """
    name = str()
    label = str()
    labelText = 'CIMChartTextProperties'
    labelPosition = ChartPosition.ChartPosition_Top
    valueFrom = 0.0
    valueTo = 0.0
    timeFrom = GetPythonClass('datetime', 'datetime')
    timeTo = GetPythonClass('datetime', 'datetime')
    visible = True
    guideType = ChartGuideType.ChartGuideType_Line
    guideValueType = ChartValueType.ChartValueType_Numeric
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLegend():
    """
      Provides access to members that control chart legend properties.
    """
    visible = True
    title = str()
    showTitle = True
    alignment = ChartLegendAlignment.Right
    valueFormat = str()
    legendText = 'CIMChartTextProperties'
    legendTitle = 'CIMChartTextProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLineSymbolProperties():
    """
      Provides access to members that control properties of the line
        /// symbol.
    """
    visible = True
    width = 2
    style = ChartLineDashStyle.Solid
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLocationDefinition():
    """
      Represents the definition of a location for which data is to be 
      plotted.
    """
    geometry = GetPythonClass('arcpy', 'Geometry')
    symbol = 'CIMSymbolReference'
    label = str()
    enabled = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartMarkerSymbolProperties():
    """
      Provides access to members that control properties of the marker
        /// symbol.
    """
    visible = True
    width = 2
    height = 2
    style = ChartMarkerSymbolStyle.Circle
    color = 'CIMColor'
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartSeries():
    """
      Provides access to members that control chart series properties.
    """
    name = str()
    uniqueName = str()
    fields = []
    orderFields = []
    groupFields = []
    whereClause = str()
    showLabels = False
    horizontalAxis = 0
    verticalAxis = 1
    colorType = ChartColorType.SingleColor
    fieldAggregation = []
    orderFieldsSortTypes = []
    visible = True
    dataLabelText = 'CIMChartTextProperties'
    multiSeries = False
    locations = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileBand():
    """
      Represents a band for a variable to be plotted over time.
    """
    bandID = -1
    symbol = 'CIMSymbolReference'
    label = str()
    locationID = -1
    dimension = str()
    dimensionValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileBands():
    """
      Represents the bands for a variable to be plotted over time.
    """
    variable = str()
    bands = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileCCDCArguments():
    """
      Represents arguments to be used to plot change detection over time.
    """
    bands = []
    temporalMaskBandIDs = []
    updatingFrequency = float('nan')
    chiSquaredThreshold = float('nan')
    minimumAnomaly = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileDimensionValue():
    """
      Represents a dimension value for a given variable to be plotted 
      over time.
    """
    value = float('nan')
    symbol = 'CIMSymbolReference'
    label = str()
    locationID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileDimensionValues():
    """
      Represents dimension values for a given variable to be plotted 
      over time.
    """
    variable = str()
    dimension = str()
    values = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileLandTrendRArguments():
    """
      Represents arguments to be used to plot change detection over time.
    """
    band = 'CIMChartTemporalProfileBand'
    snappingDate = str()
    maximumSegments = 0
    vertexCountOvershoot = 0
    spikeThreshold = float('nan')
    recoveryThreshold = float('nan')
    preventOneYearRecovery = False
    recoveryIncreasingTrend = False
    outputOtherBands = False
    minimumObservations = 0
    bestModelProportion = float('nan')
    pValueThreshold = float('nan')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileVariable():
    """
      Represents a variable to be plotted over time.
    """
    name = str()
    symbol = 'CIMSymbolReference'
    label = str()
    dimension = str()
    dimensionValues = []
    dimensionValuesSymbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTextProperties():
    """
      Represents chart text properties.
    """
    fontFillColor = 'CIMColor'
    fontOutlineColor = 'CIMColor'
    fontFamilyName = str()
    fontItalic = False
    fontSize = 12
    fontWeight = ChartFontWeight.Normal
    textCase = ChartTextCase.Normal
    textUnderline = False
    textStrikethrough = False
    textOverline = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridChartProperties():
    """
      Provides access to members that control grid chart properties.
    """
    miniChartsPerRow = 0
    selectedMiniChart = -1
    showPreviewChart = False
    useSeriesMinMaxForAxisX = False
    useSeriesMinMaxForAxisY = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultiSeriesChartProperties():
    """
      Provides access to members that control multi series chart properties.
    """
    enabled = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartBarSeries(CIMChartSeries):
    """
      Provides access to members that control bar chart series.
    """
    multipleBarType = ChartMultiBarType.SideBySide
    barSize = 90
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    verticalOrientation = True
    sortedCategoryValues = []
    showMovingAverage = False
    movingAverageLineSymbolProperties = 'CIMChartLineSymbolProperties'
    movingAveragePeriod = 7
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartBoxPlotSeries(CIMChartSeries):
    """
      Provides access to members that control bar chart box plot series.
    """
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    verticalOrientation = True
    showOutliers = False
    showInnerPoints = False
    showMean = False
    standardizeValues = False
    sortedCategoryValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartCalendarHeatSeries(CIMChartSeries):
    """
      Provides access to members that control CalendarHeat series.
    """
    columnTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    rowTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    nullPolicy = ChartNullPolicy.Null
    noDataColor = 'CIMColor'
    classificationMethod = ClassificationMethod.GeometricalInterval
    breaksCount = 0
    minimumBreak = 0.0
    breaks = []
    breakColors = []
    colorRamp = 'CIMColorRamp'
    includeLeapDay = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartDataClockSeries(CIMChartSeries):
    """
      Provides access to members that control DataClock series.
    """
    wedgeTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    ringTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    trimIncompleteTimeInterval = False
    nullPolicy = ChartNullPolicy.Null
    noDataColor = 'CIMColor'
    classificationMethod = ClassificationMethod.GeometricalInterval
    breaksCount = 0
    minimumBreak = 0.0
    breaks = []
    breakColors = []
    colorRamp = 'CIMColorRamp'
    showWedgeLabel = True
    wedgeLabelText = 'CIMChartTextProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartHistogramSeries(CIMChartSeries):
    """
      Provides access to members that control histogram series.
    """
    binCount = 8
    showMean = False
    showMedian = False
    showStandardDeviation = False
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    meanLineSymbolProperties = 'CIMChartLineSymbolProperties'
    medianLineSymbolProperties = 'CIMChartLineSymbolProperties'
    standardDeviationLineSymbolProperties = 'CIMChartLineSymbolProperties'
    showComparisonDistribution = False
    dataTransformationType = ChartDataTransformationType.eNone
    dataTransformationParameters = []
    distributionLineSymbolProperties = 'CIMChartLineSymbolProperties'
    countField = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLineSeries(CIMChartSeries):
    """
      Provides access to members that control line series.
    """
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    timeAggregationType = ChartTimeAggregationType.eNone
    timeIntervalUnits = esriTimeUnits.esriTimeUnitsUnknown
    timeIntervalSize = 0.0
    calculateAutomaticTimeInterval = True
    trimIncompleteTimeInterval = False
    nullPolicy = ChartNullPolicy.Null
    verticalOrientation = True
    sortedCategoryValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartMatrixHeatSeries(CIMChartSeries):
    """
      Provides access to members that control MatrixHeat series.
    """
    nullPolicy = ChartNullPolicy.Null
    noDataColor = 'CIMColor'
    classificationMethod = ClassificationMethod.GeometricalInterval
    breaksCount = 0
    minimumBreak = 0.0
    breaks = []
    breakColors = []
    colorRamp = 'CIMColorRamp'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartProbabilityPlotSeries(CIMChartSeries):
    """
      Provides access to members that control probability plot series.
    """
    probabilityPlotType = ChartProbabilityPlotType.NormalQQPlot
    dataTransformationType = ChartDataTransformationType.eNone
    dataTransformationParameters = []
    showReferenceLine = True
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    referenceLineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartProfileGraphSeries(CIMChartSeries):
    """
      Provides access to members that control profile graph series.
    """
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    horizontalUnit = str()
    verticalUnit = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartScatterPlotMatrixSeries(CIMChartSeries):
    """
      Provides access to members that control scatter plot matrix series.
    """
    showHistograms = False
    showTrendLine = False
    showAsRSquared = False
    fieldLabels = []
    scatterMarkerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    histogramFillSymbolProperties = 'CIMChartFillSymbolProperties'
    selectedMiniPlot = -2
    rSquareText = 'CIMChartTextProperties'
    selectionLineSymbolProperties = 'CIMChartLineSymbolProperties'
    displayOption = ChartSPMDisplayOption.PreviewPlot
    lowerLeftDisplayOption = ChartSPMDisplayOption.ScatterPlots
    lowerLeftColorRamp = 'CIMColorRamp'
    lowerLeftBreakColors = []
    upperRightColorRamp = 'CIMColorRamp'
    upperRightBreakColors = []
    diagonalOption = ChartSPMDiagonalOption.eNone
    sortByType = ChartSPMSortByType.RSquared
    sortDirection = ChartSortDirection.Ascending
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartScatterSeries(CIMChartSeries):
    """
      Provides access to members that control point chart series.
    """
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    showTrendLine = False
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    trendLineFitType = ChartTrendLineFitType.ChartTrendLineFitType_Linear
    trendOrder = 0
    showTrendEquation = False
    bubbleMinimumSize = 0.0
    bubbleMaximumSize = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartSpectralProfileSeries(CIMChartSeries):
    """
      Represents a chart spectral profile series.
    """
    displayMode = SpectralProfileDisplayMode.MeanLine
    showOutliers = False
    standardizeValues = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileSeries(CIMChartSeries):
    """
      Represents a temporal profile chart series.
    """
    plotType = ChartTemporalProfilePlotType.Variable
    variables = []
    bands = 'CIMChartTemporalProfileBands'
    dimensionValues = 'CIMChartTemporalProfileDimensionValues'
    standardizeValues = False
    timeIntervalSize = -1.0
    timeIntervalUnits = esriTimeUnits.esriTimeUnitsMonths
    timeAggregationType = ChartTimeAggregationType.eNone
    trimIncompleteTimeInterval = False
    dateTimeFormat = str()
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    showTrendLine = False
    trendLineFitType = ChartTrendLineFitType.ChartTrendLineFitType_Linear
    trendOrder = 1
    showTrendEquation = False
    spatialAggregationType = ChartAggregationType.eNone
    cCDCArguments = 'CIMChartTemporalProfileCCDCArguments'
    landTrendRArguments = 'CIMChartTemporalProfileLandTrendRArguments'
    timeExtent = TimeExtent
    def __init__(self, *args, **Kwargs):
        pass
    
