﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMBinaryReference():
    """
      Represents a binary reference in a document.
    """
    uRI = str()
    data = str()
    object = CIMObject
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCameraEffect():
    """
      Represents a camera effect definition to be applied to a 3D view.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorReplacementRule():
    """
      Represents a color replacement rule.
    """
    inputColor = 'CIMColor'
    outputColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGISProject():
    """
      Represents a project.
    """
    views = []
    moduleSettings = []
    projectItems = []
    databaseConnections = []
    serverConnections = []
    folderConnections = []
    viewLayoutXML = str()
    defaultGeoDatabase = str()
    defaultToolbox = str()
    defaultSpatialReference = str()
    defaultFolder = str()
    projectMetadata = str()
    sourceURI = str()
    sourceModifiedTime = GetPythonClass('datetime', 'datetime')
    readOnly = False
    forceUpdate = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMModuleSettings():
    """
      Represents module settings in the project.
    """
    moduleName = str()
    settingsXML = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProjectItem():
    """
      Represents an item in the project.
    """
    alias = str()
    iD = str()
    catalogPath = str()
    pathHint = str()
    itemType = str()
    name = str()
    propertiesXML = str()
    sourceURI = str()
    sourceModifiedTime = GetPythonClass('datetime', 'datetime')
    consolidatePath = False
    consolidationResources = []
    pathSaveRelative = False
    metadataURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollection():
    """
      A statistical data collection is used by the Business Analyst to 
      organize and present data that can be aggregated by the enrich 
      functionality. This is not the storage of the data, it is metadata 
      about the data that describes how data will be aggregated by Business 
      Analyst. Currently, data can be calculated by defining what data 
      collections and analysis variables are needed in the output for 
      a given input features.
    """
    name = str()
    shortDescription = str()
    longDescription = str()
    keywords = []
    countries = []
    categories = []
    author = str()
    creationDate = GetPythonClass('datetime', 'datetime')
    lastRevisionDate = GetPythonClass('datetime', 'datetime')
    calculators = []
    dataVintage = str()
    dataVintageDescription = str()
    icon = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionCalculator():
    """
      Base class for statistical data collection calculator.
    """
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionField():
    """
      Represents a field of a statistical data collection that matches 
      to existing field in referenced feature dataset.
    """
    name = str()
    alias = str()
    category = str()
    apportionmentMethod = str()
    summaryType = StatisticalDataCollectionSummaryType.Avg
    weightFieldName = str()
    precision = 0
    fieldFormat = ''
    vintage = str()
    script = str()
    scriptLanguage = LabelExpressionEngine.Python
    usedFields = []
    showInDataBrowser = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionStandardVariable():
    """
      Represents a field of a statistical data collection that matches 
      to an existing variable in referenced feature dataset.
    """
    name = str()
    showInDataBrowser = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVersion():
    """
      Represents a version object used for representing the saved version.
    """
    version = str()
    build = int()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMView():
    """
      Represents a view in the project.
    """
    viewXML = str()
    viewableObjectPath = str()
    viewType = str()
    instanceID = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVisualEffect():
    """
      Represents a visual effect definition for stylized rendering of 
      all the content in a map or scene.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBlackAndWhiteEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene to black 
      and white.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBookmarkDocument(CIMVersion):
    """
      Represents a bookmark document which is the document type used 
      for saving .bkmx files.
    """
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    bookmarks = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorReplacementDocument(CIMVersion):
    """
      Represents list of color replacement rules.
    """
    replacementRules = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCrossMosaicEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene with 
      a cross mosaic texture.
    """
    size = 4.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDepthOfFieldEffect(CIMCameraEffect):
    """
      Represents the data for simulating camera depth of field effect 
      in 3D scenes.
    """
    focusDistance = 100.0
    focusDepth = 25.0
    maxBlur = DepthOfFieldMaxBlur.Small
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDocumentInfo(CIMVersion):
    """
      Represents high level information for a document.
    """
    documentTitle = str()
    subject = str()
    author = str()
    category = str()
    comments = str()
    keywords = str()
    credits = str()
    hyperlinkBase = str()
    savePreview = False
    activeMapRepositoryPath = str()
    useRelativePath = False
    antialiasing = esriBGLAntialiasingMode.esriBGLAntialiasingNone
    textAntialiasing = esriBGLTextAAlias.esriBGLTextAAliasForce
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGenericView(CIMView):
    """
      Represents a generic view.
    """
    viewProperties = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHalftoneEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene with 
      halftone.
    """
    strength = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHexMosaicEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene with 
      a hexagonal mosaic texture.
    """
    size = 4.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerDocument(CIMVersion):
    """
      Represents a layer document which is the document type used for 
      saving .lyrx files.
    """
    layers = []
    tables = []
    layerDefinitions = []
    binaryReferences = []
    elevationSurfaces = []
    validationRules = []
    tableDefinitions = []
    rGBColorProfile = str()
    cMYKColorProfile = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayoutDocument(CIMVersion):
    """
      Represents a layout document which is the document type used for 
      saving .pagx files.
    """
    binaryReferences = []
    layerDefinitions = []
    mapDefinitions = []
    tableDefinitions = []
    layoutDefinition = 'CIMLayout'
    linkChartDefinitions = []
    timelineDefinitions = []
    videoDefinitions = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapDocument(CIMVersion):
    """
      Represents a map document which is the document type used for saving 
      .mapx files.
    """
    mapDefinition = 'CIMMap'
    layerDefinitions = []
    binaryReferences = []
    tableDefinitions = []
    linkChartDefinitions = []
    timelineDefinitions = []
    videoDefinitions = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapView(CIMView):
    """
      Represents a map view in the project.
    """
    viewingMode = MapViewingMode.Map
    camera = 'CIMViewCamera'
    verticalExaggerationScaleFactor = 1.0
    timeDisplay = 'CIMMapTimeDisplay'
    layerRanges = []
    rangeSliderSettings = 'CIMSliderSettings'
    timeSliderSettings = 'CIMSliderSettings'
    floorFilterSettings = 'CIMFloorFilterSettings'
    sceneDrawingMode = SceneDrawingMode.Perspective
    fieldOfView = 55.0
    pauseDrawing = False
    pauseAnimatedSymbols = False
    exploratoryAnalysis = []
    useVisualEffect = False
    visualEffect = 'CIMVisualEffect'
    useCameraEffect = False
    cameraEffect = 'CIMCameraEffect'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMonochromaticEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene to monochromatic 
      tones.
    """
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionDocument(CIMVersion):
    """
      Represents a document used for saving statistical data collections.
    """
    statisticalDataCollection = 'CIMStatisticalDataCollection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionFeatureLayerCalculator(CIMStatisticalDataCollectionCalculator):
    """
      Statistical data collection calculator based on a feature layer.
    """
    datasetID = str()
    dataConnection = 'CIMDataConnection'
    fields = []
    apportionmentDatasetConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionScriptCalculator(CIMStatisticalDataCollectionCalculator):
    """
      Statistical data collection calculator based on a scripts that 
      use fields from other calculators.
    """
    scripts = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStatisticalDataCollectionStandardDataCalculator(CIMStatisticalDataCollectionCalculator):
    """
      Statistical data collection calculator based on a standard local 
      data.
    """
    datasetID = str()
    variables = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableView(CIMView):
    """
      Represents a table view in the project.
    """
    fieldOrder = str()
    sortInformation = {}
    selectionMode = False
    honorTime = False
    frozenFields = 0
    zoomLevel = 0
    fieldWidth = {}
    displaySubtypeDomainDescriptions = False
    qualifyJoinFieldNames = False
    time = TimeValue
    honorRange = True
    ranges = []
    extent = GetPythonClass('arcpy', 'Extent')
    timeRelation = esriTimeRelation.esriTimeRelationOverlaps
    showOnlyContingentValueFields = False
    highlightInvalidContingentValueFields = False
    autoPopulateContingentValueFields = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTiltShiftEffect(CIMCameraEffect):
    """
      Represents the data for simulating camera tilt-shift effect for 
      creating a miniaturization effect in 3D scenes.
    """
    blurStrength = 1.0
    leftOffset = 10.0
    rightOffset = 10.0
    topOffset = 10.0
    bottomOffset = 10.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMToonEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene with 
      a cartoon style.
    """
    strength = 0.15
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWatercolorEffect(CIMVisualEffect):
    """
      Represents a visual effect for reshading the map or scene with 
      a watercolor style.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMExternalTableView(CIMTableView):
    """
      Represents an external table view.
    """
    dataConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapTableView(CIMTableView):
    """
      Represents a map table view in the project.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
