﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMAuxiliaryRasterProperties():
    """
      Represents auxiliary raster properties.
    """
    bandIndexes = []
    extent = GetPythonClass('arcpy', 'Extent')
    height = 0
    width = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMosaicRule():
    """
      Represents a mosaic rule.
    """
    ascending = True
    fIDs = []
    lockRasterID = str()
    mosaicMethod = RasterMosaicMethod.eNone
    mosaicOperatorType = RasterMosaicOperatorType.First
    orderByBaseValue = object()
    orderByFieldName = str()
    timeValue = TimeValue
    viewpoint = GetPythonClass('arcpy', 'Point')
    whereClause = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMOrthoRectification():
    """
      Represents orthorectification properties.
    """
    constantZ = 0.0
    zFactor = 0.0
    zOffset = 0.0
    geoid = False
    dEM = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPansharpeningFilter():
    """
      Represents a pansharpening filter.
    """
    panImage = 'CIMDataConnection'
    pansharpeningType = PansharpeningType.IHS
    infraredImage = 'CIMDataConnection'
    rWeight = 0.0
    gWeight = 0.0
    bWeight = 0.0
    iWeight = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterClassBreak():
    """
      Represents a raster class break.
    """
    upperBound = 0.0
    label = str()
    description = str()
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterColorCorrection():
    """
      Represents a raster color correction configuration.
    """
    preStretchType = ColorCorrectionStretchType.eNone
    colorBalanceMethod = ColorBalanceMethod.eNone
    colorMatchingMethod = ColorMatchingMethod.eNone
    needContrastAdjustment = False
    targetColorSurfaceType = TargetColorSurfaceType.SingleColorPoint
    targetColorRaster = 'CIMDataConnection'
    userDefinedReference = False
    referenceOID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterColorizerMapping():
    """
      Represents a raster colorizer mapping.
    """
    rasterOID = 0
    colorizerIndex = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterDimensionalDefinition():
    """
      Represents a set of criteria used to define the multidimensional 
      extent of a raster layer.
    """
    variableName = str()
    dimensionName = str()
    minimumValues = []
    maximumValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterHistogramEditInfo():
    """
      Represents raster histogram custom stretch edit info.
    """
    breakPointsX = []
    breakPointsY = []
    editType = RasterHistogramEditType.Lines
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterMultidimensionalDisplayDefinition():
    """
      Represents a multidimensional display definition for the current 
      display slice.
    """
    variableName = str()
    timeValue = TimeExtent
    hasRangeDimension = False
    rangeDimensionName = str()
    rangeDimensionValue = 'CIMRange'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterMultidimensionalExtentDefinition():
    """
      Represents a multidimensional extent applicable to a raster layer.
    """
    subsetDefinitions = []
    areaOfInterest = GetPythonClass('arcpy', 'Geometry')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterStretchClass():
    """
      Represents a raster stretch class.
    """
    label = str()
    value = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterUniqueValueClass():
    """
      Represents a raster unique value class.
    """
    values = []
    label = str()
    description = str()
    color = 'CIMColor'
    editable = False
    visible = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterUniqueValueGroup():
    """
      Represents a raster unique value group.
    """
    classes = []
    heading = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRenderingRule():
    """
      Represents a raster rendering rule.
    """
    description = str()
    name = str()
    variableName = str()
    arguments = {}
    definition = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVideoTimelineIndicator():
    """
      Represents an indicator on a video timeline.
    """
    label = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMFeatureLayer
class CIMFeatureMosaicSubLayer(CIMFeatureLayer):
    """
      Represents mosaic feature sub layer.
    """
    mosaicSubLayerType = MosaicSubLayerType.Boundary
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMMosaicLayer(CIMBaseLayer):
    """
      Represents a mosaic layer corresponding to a mosaic dataset.
    """
    boundaryLayer = str()
    footprintLayer = str()
    imageLayer = str()
    seamlineLayer = str()
    mosaicDatasetConnection = 'CIMDataConnection'
    timeDefinition = 'CIMTimeDataDefinition'
    timeDisplayDefinition = 'CIMTimeDisplayDefinition'
    timeFields = 'CIMTimeTableDefinition'
    definitionExpression = str()
    definitionExpressionName = str()
    definitionFilterChoices = []
    rangeDefinitions = []
    activeRangeName = str()
    activeVariables = []
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMNITFDataConnection(CIMDataConnection):
    """
      Represents a NITF data connection.
    """
    uRI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNitfFeatureSubLayer(CIMFeatureLayer):
    """
      Represents NITF feature sub layer.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNitfLayer(CIMBaseLayer):
    """
      Represents a NITF composite layer.
    """
    dataConnection = 'CIMDataConnection'
    layers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterBandDataConnection(CIMDataConnection):
    """
      Represents a raster band data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a raster band data connection.
    """
    rasterBandName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMGeoFeatureLayerBase
class CIMRasterCatalogLayer(CIMGeoFeatureLayerBase):
    """
      Represents a raster catalog layer.
    """
    displayRastersThreshold = 9
    drawRastersOnly = False
    fixedLabelPositions = False
    colorizerMapping = []
    colorizers = []
    resamplingType = RasterResamplingType.NearestNeighbor
    transitionScale = 0.0
    useColorCorrection = False
    useScale = False
    wireFrameSymbol = 'CIMSymbolReference'
    sortFieldAscending = False
    sortField = str()
    colorCorrection = 'CIMRasterColorCorrection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterLayer(CIMBaseLayer):
    """
      Represents a raster layer which displays raster imagery stored 
      in a raster dataset.
    """
    dataConnection = 'CIMDataConnection'
    colorizer = 'CIMRasterColorizer'
    attributeTable = 'CIMRasterTable'
    timeDisplayDefinition = 'CIMTimeDisplayDefinition'
    timeDimensionFields = 'CIMTimeDimensionDefinition'
    timeDefinition = 'CIMTimeDataDefinition'
    auxiliaryRasterProperties = 'CIMAuxiliaryRasterProperties'
    autoComputeStatsHistogram = False
    rangeDefinitions = []
    activeRangeName = str()
    activeVariables = []
    multidimensionalExtent = 'CIMRasterMultidimensionalExtentDefinition'
    activeSlice = 'CIMRasterMultidimensionalDisplayDefinition'
    renderingRule = 'CIMRenderingRule'
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMStandaloneVideo(CIMDefinition):
    """
      Represents a standalone video.
    """
    dataConnection = 'CIMVideoDataConnection'
    footprintColor = 'CIMColor'
    elapsedTime = 0.0
    visibility = True
    expanded = True
    frameCenterGraphic = 'CIMVideoGraphicElement'
    frameOutlineGraphic = 'CIMVideoGraphicElement'
    platformTrailGraphic = 'CIMVideoGraphicElement'
    platformPositionGraphic = 'CIMVideoGraphicElement'
    bookmarkIndicators = []
    exportFrameIndicators = []
    exportToPPTIndicators = []
    exportFramesIndicators = []
    metadataToCSVIndicators = []
    recordVideoIndicators = []
    exportSegmentIndicators = []
    recordSegmentsIndicators = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVideoDataConnection(CIMDataConnection):
    """
      Represents a video data connection.
    """
    uRI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayout import CIMGraphicElement
class CIMVideoGraphicElement(CIMGraphicElement):
    """
      Represents video-related graphic being displayed on the map.
    """
    expanded = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMImageServiceLayer(CIMRasterLayer):
    """
      Represents an image service layer corresponding to an ArcGIS Server 
      image service.
    """
    compression = str()
    compressionQuality = 0
    drawFootprints = False
    featureTable = 'CIMFeatureTable'
    footprintDrawMode = RasterFootprintDrawMode.OnlyPrimary
    footprintSymbol = 'CIMSymbolReference'
    mosaicRule = 'CIMMosaicRule'
    selectable = True
    selectionColor = 'CIMColor'
    selectionSymbol = 'CIMSymbolReference'
    useSelectionSymbol = True
    ignoreRenderingRuleOnIdentify = False
    useServiceCache = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNitfImageSubLayer(CIMRasterLayer):
    """
      Represents NITF image sub layer.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterColorizer(CIMOrthoRectification):
    """
      Represents a raster colorizer.
    """
    resamplingType = RasterResamplingType.NearestNeighbor
    contrast = 0
    brightness = 0
    noDataColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterDiscreteColorColorizer(CIMRasterColorizer):
    """
      Represents a raster discrete color colorizer.
    """
    numColors = 0
    colormap = RasterColormap
    colorRamp = 'CIMColorRamp'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterRGBColorizer(CIMRasterColorizer):
    """
      Represents a raster RGB colorizer.
    """
    alphaBandIndex = -1
    backgroundColor = 'CIMColor'
    backgroundValueBlue = 0
    backgroundValueGreen = 0
    backgroundValueRed = 0
    blueBandIndex = 2
    blueLookup = []
    displayBackgroundValue = False
    eSRIStretchContrastB = 0
    eSRIStretchContrastG = 0
    eSRIStretchContrastR = 0
    eSRIStretchMeanB = 0
    eSRIStretchMeanG = 0
    eSRIStretchMeanR = 0
    gammaB = 1.0
    gammaG = 1.0
    gammaR = 1.0
    greenBandIndex = 1
    greenLookup = []
    invert = False
    lumLookup = []
    maxPercent = 2.0
    minPercent = 2.0
    pansharpeningFilter = 'CIMPansharpeningFilter'
    redBandIndex = 0
    redLookup = []
    specificationHistogramBlue = StatsHistogram
    specificationHistogramGreen = StatsHistogram
    specificationHistogramRed = StatsHistogram
    standardDeviationsParam = 2.0
    stretchStatsBlue = StatsHistogram
    stretchStatsGreen = StatsHistogram
    stretchStatsRed = StatsHistogram
    stretchStatsType = RasterStretchStatsType.Dataset
    stretchType = RasterStretchType.Count
    useAlphaBand = False
    useBlueBand = True
    useDefaultMapping = True
    useGammaStretch = False
    useGreenBand = True
    useRedBand = True
    heading = str()
    useCustomStretchMinMax = False
    customStretchMinRed = 0.0
    customStretchMinGreen = 0.0
    customStretchMinBlue = 0.0
    customStretchMaxRed = 1.0
    customStretchMaxGreen = 1.0
    customStretchMaxBlue = 1.0
    histogramEditInfoRed = 'CIMRasterHistogramEditInfo'
    histogramEditInfoGreen = 'CIMRasterHistogramEditInfo'
    histogramEditInfoBlue = 'CIMRasterHistogramEditInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterShadedReliefColorizer(CIMRasterColorizer):
    """
      Represents a raster shaded relief colorizer.
    """
    colorRamp = 'CIMColorRamp'
    hillShadeType = ColorizerHillshadeType.Traditional
    scalingType = ColorizerScalingType.eNone
    pixelSizePower = 0.664
    pixelSizeFactor = 0.024
    azimuth = 315.0
    altitude = 45.0
    removeEdgeEffect = False
    useMapIlluminationProperties = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterStretchColorizer(CIMRasterColorizer):
    """
      Represents a raster stretch colorizer.
    """
    backgroundColor = 'CIMColor'
    backgroundValue = 0.0
    bandIndex = 0
    colorRamp = 'CIMColorRamp'
    colorScheme = str()
    customStretchMax = 1.0
    customStretchMin = 0.0
    displayBackgroundValue = False
    eSRIStretchContrast = 0
    eSRIStretchMean = 0
    gammaValue = 1.0
    hillshadeZFactor = 1.0
    invert = False
    lookup = []
    maxPercent = 2.0
    minPercent = 2.0
    standardDeviationParam = 2.0
    statsHistogram = StatsHistogram
    statsType = RasterStretchStatsType.Dataset
    stretchClasses = []
    stretchStats = StatsHistogram
    stretchType = RasterStretchType.Count
    useCustomMinMax = False
    useCustomStretchMinMax = False
    useGammaStretch = False
    useHillshade = False
    numberFormat = 'CIMNumberFormat'
    heading = str()
    specificationHistogram = StatsHistogram
    histogramEditInfo = 'CIMRasterHistogramEditInfo'
    useAdvancedLabeling = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterUniqueValueColorizer(CIMRasterColorizer):
    """
      Represents a raster unique value colorizer.
    """
    defaultColor = 'CIMColor'
    useDefaultColor = False
    fieldName = str()
    groups = []
    colorRamp = 'CIMColorRamp'
    defaultLabel = str()
    defaultDescription = str()
    numberFormat = 'CIMNumberFormat'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterVectorFieldColorizer(CIMRasterColorizer):
    """
      Represents a raster vector field colorizer.
    """
    magnitudeBandIndex = 0
    directionBandIndex = 1
    isUVComponents = False
    referenceSystem = SymbolRotationType.Geographic
    flowRepresentation = FlowRepresentationType.From
    symbolTileSize = 50.0
    symbolTileSizeUnits = SymbolTileUnitType.Pixels
    symbolizationType = SymbolizationType.SingleArrow
    symbol = 'CIMSymbolReference'
    classBreaks = []
    minimumClassBreak = 0
    minimumMagnitude = float('inf')
    maximumMagnitude = float('-inf')
    minimumSymbolSize = 20.0
    maximumSymbolSize = 80.0
    fromUnit = SpeedUnitType.Unknown
    toUnit = SpeedUnitType.Unknown
    numberFormat = 'CIMNumberFormat'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVideoTimelineEventIndicator(CIMVideoTimelineIndicator):
    """
      Represents an event indicator on a video timeline.
    """
    time = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVideoTimelineRangeIndicator(CIMVideoTimelineIndicator):
    """
      Represents a range indicator on a video timeline.
    """
    minimum = -1
    maximum = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMImageMosaicSubLayer(CIMImageServiceLayer):
    """
      Represents an image mosaic sublayer.
    """
    mosaicSubLayerType = MosaicSubLayerType.Boundary
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterCMYKColorizer(CIMRasterColorizer):
    """
      Represents a raster CMYK colorizer.
    """
    backgroundColor = 'CIMColor'
    backgroundValueBlack = 0
    backgroundValueCyan = 0
    backgroundValueMagenta = 0
    backgroundValueYellow = 0
    blackBandIndex = 3
    cyanBandIndex = 0
    displayBackgroundValue = True
    invert = False
    magentaBandIndex = 1
    specificationHistogramBlack = StatsHistogram
    specificationHistogramCyan = StatsHistogram
    specificationHistogramMagenta = StatsHistogram
    specificationHistogramYellow = StatsHistogram
    standardDeviationParam = 2.0
    stretchStatsBlack = StatsHistogram
    stretchStatsCyan = StatsHistogram
    stretchStatsMagenta = StatsHistogram
    stretchStatsType = RasterStretchStatsType.Dataset
    stretchStatsYellow = StatsHistogram
    stretchType = RasterStretchType.Count
    useBlackMapping = True
    useCyanMapping = True
    useDefaultMapping = True
    useMagentaMapping = True
    useYellowMapping = True
    yellowBandIndex = 2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterClassifyColorizer(CIMRasterColorizer):
    """
      Represents a raster classify colorizer.
    """
    normalizationField = str()
    normalizationTotal = 0.0
    normalizationType = DataNormalizationMethod.Nothing
    """
      Represents a raster classify colorizer.
    """
    classBreaks = []
    classificationMethod = ClassificationMethod.NaturalBreaks
    colorRamp = 'CIMColorRamp'
    exclusionColor = 'CIMColor'
    exclusionDescription = str()
    exclusionLabel = str()
    exclusionRanges = []
    exclusionValues = []
    field = str()
    hillshadeZFactor = 1.0
    minimumBreak = 0.0
    showClassGaps = False
    showInAscendingOrder = True
    useExclusionColor = False
    useHillshade = False
    numberFormat = 'CIMNumberFormat'
    heading = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterColorMapColorizer(CIMRasterColorizer):
    """
      Represents a raster color map colorizer.
    """
    colors = []
    bandID = -1
    labels = []
    min = 0
    max = 255
    numberFormat = 'CIMNumberFormat'
    values = []
    def __init__(self, *args, **Kwargs):
        pass
    
