﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMKnowledgeGraphDataLoadingConfiguration():
    """
      Represents a Knowledge Graph Data Loading Configuration.
    """
    name = str()
    entities = []
    relationships = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphDataLoadingEntity():
    """
      Represents a Knowledge Graph Data Loading Entity.
    """
    name = str()
    type = str()
    typeIsFieldName = False
    properties = []
    merge = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphDataLoadingRelationship():
    """
      Represents a Knowledge Graph Data Loading Relationship.
    """
    sourceEntityName = str()
    type = str()
    typeIsFieldName = False
    targetEntityName = str()
    properties = []
    merge = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphLinkChartCentralityConfiguration():
    """
      Represents the Centrality computation options in a Knowledge Graph 
      Link Chart.
    """
    relationshipsInterpretation = CentralityRelationshipInterpretation.Undirected
    multiedgeFactor = 1.0
    normalization = CentralityScoresNormalization.eNone
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphLinkChartProperties():
    """
      Represents a Knowledge Graph Link Chart Properties object.
    """
    nodesURI = str()
    linksURI = str()
    aggregatedNodesURI = str()
    aggregatedLinksURI = str()
    autoCollapseRelationships = True
    rootNodesURI = str()
    rootAggregatedNodesURI = str()
    centralityConfiguration = 'CIMKnowledgeGraphLinkChartCentralityConfiguration'
    centralityIsUpToDate = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphList():
    """
      Represents a Knowledge Graph List.
    """
    name = str()
    globalIdSetURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphProperty():
    """
      Represents a Knowledge Graph Data Loading Property used for entities 
      and relationships.
    """
    name = str()
    type = esriFieldType.esriFieldTypeSmallInteger
    value = 'CIMKnowledgeGraphPropertyValue'
    merge = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphPropertyValue():
    """
      Base (indicator) class for all CIMKnowledgeGraphXXXPropertyValue.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphQuery():
    """
      Represents a Knowledge Graph Query.
    """
    name = str()
    query = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMKnowledgeGraphDataConnection(CIMDataConnection):
    """
      Represents a Knowledge Graph data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a Knowledge Graph data connection.
    """
    definitionQuery = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMKnowledgeGraphInvestigation(CIMDefinition):
    """
      Represents a Knowledge Graph Investigation.
    """
    dataConnection = 'CIMDataConnection'
    queries = []
    lists = []
    maps = []
    linkCharts = []
    dataLoadingConfigurations = []
    defaultDataLoadingConfigurationName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMKnowledgeGraphLayer(CIMBaseLayer):
    """
      Provides access to properties of a Knowledge Graph layer.
    """
    standaloneTables = []
    """
      Provides access to properties of a Knowledge Graph layer.
    """
    dataConnection = 'CIMDataConnection'
    layers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphTableDataConnection(CIMDataConnection):
    """
      Represents a Knowledge Graph data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a Knowledge Graph data connection.
    """
    definitionQuery = str()
    """
      Represents a Knowledge Graph data connection.
    """
    inclusionSetURI = str()
    exclusionSetURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMGeoFeatureLayerBase
class CIMLinkChartFeatureLayer(CIMGeoFeatureLayerBase):
    """
      Represents a Link Chart Feature Layer.
    """
    aggregationLayerURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphCoordinatePropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a coordinate property value.
    """
    fieldNames = []
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    interpretAsLongitudeLatitude = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphFieldPropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a property value from a specific import field.
    """
    fieldName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphFixedPropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a fixed string property value.
    """
    fixedValue = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphNonspatialProperty(CIMKnowledgeGraphProperty):
    """
      Represents a Knowledge Graph Data Loading Property used by entities 
      and relationships.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeGraphSpatialProperty(CIMKnowledgeGraphProperty):
    """
      Represents a Spatial Knowledge Graph Data Loading Property used 
      for entities.  This
  /// class is expected to be used only when 
      the Type of property is esriFieldTypeGeometry.
    """
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    geometryType = esriGeometryType.esriGeometryPoint
    def __init__(self, *args, **Kwargs):
        pass
    
