﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMAutoCamera():
    """
      Represents the camera settings associated with a map frame on a 
      page layout.
    """
    camera = 'CIMViewCamera'
    autoCameraType = AutoCameraType.Extent
    extent = GetPythonClass('arcpy', 'Extent')
    intersectLayerPath = str()
    mapFrameLinkName = str()
    margin = 0.0
    marginType = UnitType.Percent
    marginUnits = str()
    source = AutoCameraSource.eNone
    syncRotation = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAviationArrow():
    """
      Represents an individual arrow in CIMAviationNorthArrow.
    """
    lineIndicatorTextSymbol = 'CIMSymbolReference'
    lineSymbol = 'CIMSymbolReference'
    defaultPointSymbol = 'CIMSymbolReference'
    positivePointSymbol = 'CIMSymbolReference'
    negativePointSymbol = 'CIMSymbolReference'
    enableArrow = False
    enableLineIndicator = False
    arrowLength = 60.0
    lineIndicatorText = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAviationVariation():
    """
      Represents the properties for the variation text which is displayed 
      in aviation north arrow.
    """
    variationTextSymbol = 'CIMSymbolReference'
    alignVariationToLine = True
    variationTextOnLeft = True
    showYear = False
    showYearInParenthesis = False
    variationYearSeparator = str()
    magneticVariationIdentifier = str()
    gridVariationIdentifier = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAviationVerticalScaleProperties():
    """
      Represents a set of scale properties for aviation-specific Vertical 
      Scale Bar, such as a feet scale or meter scale properties.
    """
    unitTextSymbol = 'CIMSymbolReference'
    divisionMarkSymbol = 'CIMSymbolReference'
    subdivisionMarkSymbol = 'CIMSymbolReference'
    scaleTextSymbol = 'CIMSymbolReference'
    scaleBarHeight = 30.0
    divisionLineLength = 8
    subdivisionLineLength = 4
    scaleUnitText = str()
    divisions = 5
    subdivisions = 2
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBookmarkMapSeriesPage():
    """
      A map series page based on a bookmark.
    """
    bookmarkName = str()
    mapURI = str()
    category = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDeclination():
    """
      Represents the properties of a declination calculated using World 
      Magnetic Model.
    """
    direction = DeclinationDirection.East
    degrees = 0
    minutes = 0
    mils = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMElement():
    """
      A CIM representation of an element.
    """
    anchor = Anchor.BottomLeftCorner
    locked = False
    name = str()
    visible = True
    rotation = 0.0
    rotationCenter = GetPythonClass('arcpy', 'Point')
    lockedAspectRatio = False
    customProperties = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMExtentIndicator():
    """
      Represents an extent indicator which is used to display the visible 
      extent of other map frames in an associated map frame.
    """
    sourceMapFrame = str()
    symbol = 'CIMSymbolReference'
    leaderType = LeaderType.eNone
    leaderSymbol = 'CIMSymbolReference'
    collapseSize = 0.0
    pointSymbol = 'CIMSymbolReference'
    name = str()
    isVisible = True
    avoidLabelConflict = True
    symbolizeExterior = False
    extentIndicatorType = ExtentIndicatorType.Frame
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridEndpoint():
    """
      Represents an end point of a component. For ex: The labels for ticks are
        /// defined using an endPoint object.
    """
    gridLabelTemplate = 'CIMGridLabelTemplate'
    offset = 0
    position = 3
    lineSelection = 7
    drawLabelsParallel = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridLabelTemplate():
    """
      Represents the formatting of a label.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridLine():
    """
      Represents latitudes or longitudes for a graticule.
        /// Represents eastings or nothings for a grid.
    """
    name = str()
    elementType = GridElementType.Line
    gridLineOrientation = GridLineOrientation.EastWest
    symbol = 'CIMSymbolReference'
    pattern = 'CIMGridPattern'
    fromTick = 'CIMExteriorTick'
    toTick = 'CIMExteriorTick'
    interiorTicks = []
    visibleIndices = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridPattern():
    """
      Defines pattern for a component.
    """
    interval = 0
    start = 0
    stop = 1
    gap = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGridZoneLabelPosition():
    """
      Represents the state of a label at a given position on a MapGrid.
    """
    visible = True
    offsetX = 0.2
    offsetY = 0.2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGuide():
    """
      Represents a guide used to snap elements on a page layout.
    """
    position = 0.0
    orientation = Orientation.Horizontal
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLegendItem():
    """
      Represents a legend item.
    """
    name = str()
    newColumn = False
    layerNameSymbol = 'CIMSymbolReference'
    columns = 1
    keepTogether = False
    showLayerName = False
    showHeading = True
    headingSymbol = 'CIMSymbolReference'
    showLabels = True
    layer = str()
    showDescription = True
    labelSymbol = 'CIMSymbolReference'
    descriptionSymbol = 'CIMSymbolReference'
    patchWidth = 0.0
    patchHeight = 0.0
    autoVisibility = True
    useMapSeriesShape = False
    classIndent = 0.0
    headingIndent = 0.0
    layerNameIndent = 0.0
    showGroupLayerName = True
    groupLayerNameSymbol = 'CIMSymbolReference'
    scaleToPatch = False
    showCounts = False
    countFormat = 'CIMNumberFormat'
    countPrefix = str()
    countSuffix = str()
    isVisible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapGrid():
    """
      Represents a grid object for a map frame.
    """
    name = str()
    isVisible = True
    neatlineSymbol = 'CIMSymbolReference'
    maxInteriorAngle = 150
    edgeMinimumLength = 0.0
    mapGridEdges = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapGridEdge():
    """
      Represents a map grid edge.
    """
    partIndex = 0
    segmentIndices = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapSeries():
    """
      The Map series object represents a means to create multi-page PDF or
        /// based off of fields in the index layer.
    """
    enabled = True
    mapFrameName = str()
    startingPageNumber = 1
    currentPageID = 1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMargin():
    """
      Represents a margin to apply around the page.
    """
    left = 1.0
    right = 1.0
    top = 1.0
    bottom = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMeterReferenceProperties():
    """
      Defines the display properties of the meter reference guide.
    """
    gridSquareUpperLeft = str()
    gridSquareUpperRight = str()
    gridSquareLowerLeft = str()
    gridSquareLowerRight = str()
    gridSquareUpperLeftDual = str()
    gridSquareUpperRightDual = str()
    gridSquareLowerLeftDual = str()
    gridSquareLowerRightDual = str()
    gridSquareVerticalSeparator = 0
    gridSquareHorizontalSeparator = 0
    gridSquareHorizontalSeparatorDual = 0
    gridZoneUpperLeft = str()
    gridZoneUpperRight = str()
    gridZoneLowerLeft = str()
    gridZoneLowerRight = str()
    gridZoneLatitude = 0
    gridZoneLongitude = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPage():
    """
      Represents the page information associated with a layout.
    """
    height = 11
    stretchElements = False
    width = 8.5
    printerPreferences = 'CIMPrinterPreferences'
    units = str()
    guides = []
    showRulers = True
    showGuides = True
    smallestRulerDivision = 0.01
    margin = 'CIMMargin'
    showMargin = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPrinterPreferences():
    """
      Represents the printer preferences associated with a layout.
    """
    printerName = str()
    paperName = str()
    paperSource = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileGrid():
    """
      Grid shown for the profile.
    """
    horizontalScale = 300
    horizontalScaleUnits = str()
    verticalScale = 30
    verticalScaleUnits = str()
    autoGridExtent = True
    yMin = 0
    yMax = 1000
    subDivisionsX = 6
    subDivisionsY = 6
    gridSymbol = 'CIMSymbolReference'
    subDivisionSymbol = 'CIMSymbolReference'
    horizontalScaleTextSymbol = 'CIMSymbolReference'
    verticalScaleLeftTextSymbol = 'CIMSymbolReference'
    verticalScaleRightTextSymbol = 'CIMSymbolReference'
    showEntireApproach = True
    xMax = 2000
    verticalIntervalInMeters = 2
    verticalIntervalInFeet = 2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileOIS():
    """
      Defines the properties for OIS features.
    """
    oISDescription = str()
    oISLabel = str()
    showOIS = True
    isPrimary = False
    displayOrder = 0
    oISSymbol = 'CIMSymbolReference'
    oISTextSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileObstacle():
    """
      Represents common properties for all the obstacles.
    """
    showPenetrating = True
    obstacleLayerName = str()
    symbolSubstitutionType = ProfileObstacleSymbolSubstitutionType.eNone
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileRunway():
    """
      Display properties for Runway.
    """
    precision = 2
    elevationChangeThreshold = 10.0
    runwayLineSymbol = 'CIMSymbolReference'
    runwayTextSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileTerrain():
    """
      Display properties for Terrain.
    """
    showOutline = False
    maxTerrain = 'CIMProfileTerrainDisplay'
    minTerrain = 'CIMProfileTerrainDisplay'
    centerLineTerrain = 'CIMProfileTerrainDisplay'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileTerrainDisplay():
    """
      Settings to control how the terrain information is being displayed 
      in the profile.
    """
    displayOption = ProfileTerrainDisplayOption.All
    terrainSymbol = 'CIMSymbolReference'
    penetratingTerrainSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportDataSource():
    """
      Represents the data source properties of a report. The data source 
      can be a map member or external data.
    """
    dataConnection = 'CIMDataConnection'
    definitionQuery = str()
    fields = []
    mapMemberURI = str()
    useSelectionSet = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportElementFieldProperties():
    """
      Represents field properties that will be applied to an element 
      in a report.
    """
    element = str()
    field = str()
    format = 'CIMNumberFormat'
    statistic = FieldStatisticsFlag.NoStatistics
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportWatermark():
    """
      Represents a watermark in a report.
    """
    element = 'CIMElement'
    excludePageNumbers = str()
    isBackground = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableField():
    """
      Represents properties for a table field.
    """
    name = str()
    isVisible = False
    width = 0
    sortInfo = FieldSortInfo.eNone
    sortOrder = -1
    fieldOrder = 0
    group = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTick():
    """
      Represents a tick of a grid.
    """
    length = 1.0
    offset = 0.0
    isVisible = True
    symbol = 'CIMSymbolReference'
    gridEndpoint = 'CIMGridEndpoint'
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMLayout(CIMDefinition):
    """
      Represents a layout in a project.
    """
    elements = []
    """
      Represents a layout in a project.
    """
    page = 'CIMPage'
    dateExported = GetPythonClass('datetime', 'datetime')
    datePrinted = GetPythonClass('datetime', 'datetime')
    mapSeries = 'CIMMapSeries'
    colorModel = ColorModel.RGB
    rGBColorProfile = str()
    cMYKColorProfile = str()
    simulateOverprint = False
    customProperties = []
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMDocument import CIMView
class CIMLayoutView(CIMView):
    """
      Represents a layout view in the project.
    """
    extent = GetPythonClass('arcpy', 'Extent')
    defaultMapFrameName = str()
    pauseDrawing = False
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMDocument import CIMVersion
class CIMReportDocument(CIMVersion):
    """
      Represents a report document which is the document type used for 
      saving .rlfx files.
    """
    binaryReferences = []
    layerDefinitions = []
    mapDefinitions = []
    reportDefinition = 'CIMReport'
    tableDefinitions = []
    layoutDefinitions = []
    linkChartDefinitions = []
    timelineDefinitions = []
    videoDefinitions = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBookmarkMapSeries(CIMMapSeries):
    """
      Bookmark map series is a means to create a series of map pages 
      based on saved bookmarks.
    """
    pages = []
    scaleRounding = 0.0
    extentOptions = ExtentFitType.BestFit
    marginType = UnitType.Percent
    marginUnits = str()
    margin = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCustomGrid(CIMMapGrid):
    """
      Represents a custom grid of the mapFrame.
    """
    layerURI = str()
    gridLines = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCustomGridLabelTemplate(CIMGridLabelTemplate):
    """
      Defines the label template for custom grids.
    """
    labelExpressionInfo = 'CIMExpressionInfo'
    edgeLabelAngles = []
    symbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMExteriorTick(CIMTick):
    """
      Class that represents an exterior tick for a grid.
    """
    edgeAffinity = []
    drawPerpendicular = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFrameElement(CIMElement):
    """
      Represents the frame that is associated with some element types 
      (for example, map frame, legends and so on).
    """
    frame = GetPythonClass('arcpy', 'Polygon')
    graphicFrame = 'CIMGraphicFrame'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGZDLabelGridLine(CIMGridLine):
    """
      Represents a UTM Grid Zone Designator Label definition for a MapGrid.
    """
    dynamicStringTemplate = str()
    verticalTopPosition = 'CIMGridZoneLabelPosition'
    verticalCenterPosition = 'CIMGridZoneLabelPosition'
    verticalBottomPosition = 'CIMGridZoneLabelPosition'
    horizontalLeftPosition = 'CIMGridZoneLabelPosition'
    horizontalCenterPosition = 'CIMGridZoneLabelPosition'
    horizontalRightPosition = 'CIMGridZoneLabelPosition'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGraphicElement(CIMElement):
    """
      Represents the CIM representation of an element on a page layout.
    """
    graphic = 'CIMGraphic'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGraticule(CIMMapGrid):
    """
      Represents a graticule for a map frame.
    """
    customOrigin = GetPythonClass('arcpy', 'Point')
    geographicCoordinateSystem = GetPythonClass('arcpy', 'SpatialReference')
    gridLines = []
    isAutoScaled = False
    useMapClipShape = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupElement(CIMFrameElement):
    """
      Represents a collection of layout elements in a group element.
    """
    """
      Represents a collection of layout elements in a group element.
    """
    elements = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHorizontalBarLegendItem(CIMLegendItem):
    """
      Represents a horizontal bar legend item.
    """
    angleAbove = 45
    angleBelow = 45
    """
      Represents a horizontal bar legend item.
    """
    arrangement = LegendItemArrangement.PatchLabelDescription
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHorizontalLegendItem(CIMLegendItem):
    """
      Represents a horizontal legend item.
    """
    arrangement = LegendItemArrangement.PatchLabelDescription
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMInteriorTick(CIMTick):
    """
      Class that represents an interior tick for a grid.
    """
    pattern = 'CIMGridPattern'
    indicateDirection = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLadderGridLine(CIMGridLine):
    """
      Represents internal labels for a MapGrid.
    """
    dynamicStringTemplate = str()
    gapX = 0.0
    gapY = 0.0
    position = GridLadderLabelPosition.Half
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMGRSGridLine(CIMGridLine):
    """
      Represents a gridLine to draw the 100,000 MGRS grids.
    """
    xOffset = 2.0
    yOffset = 2.0
    labelPosition = MGRSLabelPosition.Center
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapFrame(CIMFrameElement):
    """
      Represents a map frame on a page layout.
    """
    autoCamera = 'CIMAutoCamera'
    uRI = str()
    view = 'CIMMapView'
    extentIndicators = []
    grids = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapSurround(CIMFrameElement):
    """
      Represents a map surround on a page layout.
    """
    mapFrame = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMeasuredGrid(CIMMapGrid):
    """
      Represents a measured grid of the mapFrame.
    """
    customOrigin = GetPythonClass('arcpy', 'Point')
    projectedCoordinateSystem = GetPythonClass('arcpy', 'SpatialReference')
    gridLines = []
    isAutoScaled = False
    clipUTMZone = False
    useMapClipShape = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMeterReferenceGuide(CIMMapSurround):
    """
      Provides a set of instructions and examples that enable users to 
      compose standard grid reference.
    """
    autoUpdate = True
    specificationType = MeterReferenceSpecType.TLM
    gridSquareType = MeterReferenceSquareType.Single
    isSingleGridZone = True
    properties = 'CIMMeterReferenceProperties'
    textSymbol = 'CIMSymbolReference'
    lineSymbol = 'CIMSymbolReference'
    productSpecification = MapProductSpecType.TLM
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNestedLegendItem(CIMLegendItem):
    """
      Represents a nested legend item in a legend.
    """
    arrangement = LegendItemArrangement.PatchLabelDescription
    """
      Represents a nested legend item in a legend.
    """
    autoLayout = True
    labelEnds = False
    leaderSymbol = 'CIMSymbolReference'
    outlineSymbol = 'CIMSymbolReference'
    leaderOverhang = 10
    showOutlines = False
    textHorizontalAlignment = HorizontalAlignment.Center
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNorthArrow(CIMMapSurround):
    """
      Represents a north arrow on a page layout.
    """
    referenceLocation = GetPythonClass('arcpy', 'Point')
    calibrationAngle = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfileFrame(CIMMapSurround):
    """
      Layout element used to draw Profile view of
        /// Runway, Terrain, obstacles and Obstruction Identification 
      Surfaces (OIS).
    """
    heightOption = ProfileFrameHeightOption.ConstantHeight
    height = 2
    heightUnits = str()
    ratio = 10
    runwayDesignator = str()
    primaryOISDescription = str()
    secondaryOISDescription = str()
    oISLayerURI = str()
    grid = 'CIMProfileGrid'
    terrain = 'CIMProfileTerrain'
    runway = 'CIMProfileRunway'
    oISSurfaces = []
    obstacles = []
    profileType = ProfileFrameType.Straight
    profileStyle = ProfileFrameStyle.AOC
    runwayEndLeftAsReference = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfilePointObstacle(CIMProfileObstacle):
    """
      Defines the properties for a Point obstacle.
    """
    markerLocation = ProfileObstacleMarkerLocation.Surface
    obstacleBaseSymbol = 'CIMSymbolReference'
    obstacleHeightSymbol = 'CIMSymbolReference'
    obstacleMarkerSymbol = 'CIMSymbolReference'
    obstacleTextSymbol = 'CIMSymbolReference'
    showOnlyShadowingObstacles = False
    substituteObstacleBaseSymbol = 'CIMSymbolReference'
    substituteObstacleHeightSymbol = 'CIMSymbolReference'
    substituteObstacleMarkerSymbol = 'CIMSymbolReference'
    substituteObstacleTextSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProfilePolyObstacle(CIMProfileObstacle):
    """
      Represents a profile poly obstacle.
    """
    groundDisplayOption = ProfileObstacleGroundDisplayOption.Max
    obstacleSymbol = 'CIMSymbolReference'
    substituteObstacleSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReferenceGrid(CIMMapGrid):
    """
      Defines a reference grid.
    """
    isAutoScaled = False
    rowCount = 0
    columnCount = 0
    gridLines = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReferenceGridLabelTemplate(CIMGridLabelTemplate):
    """
      Defines the label template for the reference grids.
    """
    name = str()
    values = []
    delimiter = str()
    symbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReport(CIMLayout):
    """
      Represents a report in a project.
    """
    height = 0
    startPage = 1
    watermarks = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportField(CIMTableField):
    """
      Represents a field in a report.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportSectionElement(CIMGroupElement):
    """
      Represents a section of elements in a report.
    """
    autoSize = False
    elementFieldProperties = []
    excludePageNumberPages = str()
    excludeSectionPages = str()
    startOnNewPage = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScaleBar(CIMMapSurround):
    """
      Represents a scale bar on a page layout.
    """
    alignToZeroPoint = False
    barHeight = 0.0
    division = 100.0
    divisions = 2
    divisionsBeforeZero = 1
    fittingStrategy = ScaleBarFittingStrategy.AdjustDivision
    labelFrequency = ScaleBarFrequency.DivisionsAndFirstMidpoint
    labelGap = 3.0
    labelPosition = ScaleBarVerticalPosition.Above
    labelSymbol = 'CIMSymbolReference'
    numberFormat = 'CIMNumberFormat'
    subdivisions = 4
    unitLabel = str()
    unitLabelGap = 3.0
    unitLabelPosition = ScaleBarLabelPosition.AfterLabels
    unitLabelSymbol = 'CIMSymbolReference'
    units = str()
    useFractionCharacters = False
    zeroPoint = GetPythonClass('arcpy', 'Point')
    computeAtCenter = False
    displayFirstOutside = False
    displayLastOutside = False
    """
      Represents a scale bar on a page layout.
    """
    divisionMarkHeight = 7.0
    divisionMarkSymbol = 'CIMSymbolReference'
    markFrequency = ScaleBarFrequency.DivisionsAndFirstSubdivisions
    markPosition = ScaleBarVerticalPosition.Above
    subdivisionMarkHeight = 5.0
    subdivisionMarkSymbol = 'CIMSymbolReference'
    midpointMarkHeight = 5.0
    midpointMarkSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScaleLine(CIMScaleBar):
    """
      Represents a Scale line on a page layout.
    """
    lineSymbol = 'CIMSymbolReference'
    stepped = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSimpleGridLabelTemplate(CIMGridLabelTemplate):
    """
      Represents a simple format for a label.
    """
    dynamicStringTemplate = str()
    symbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSingleFillScaleBar(CIMScaleBar):
    """
      Represents and single fill scale bar on a page layout.
    """
    fillSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSlopeGuide(CIMMapSurround):
    """
      A slope guide surround element which is used to ascertaining terrain 
      slope graphically /// as a percentage and a gradient (degree).
    """
    autoUpdate = True
    slopeGuideLayerURI = str()
    contourIntervalField = str()
    mapScale = 50000
    contourInterval = 20
    titleTextSymbol = 'CIMSymbolReference'
    slopeUnitTextSymbol = 'CIMSymbolReference'
    slopeTextSymbol = 'CIMSymbolReference'
    footnoteTextSymbol = 'CIMSymbolReference'
    verticalLineSymbol = 'CIMSymbolReference'
    horizontalLineSymbol = 'CIMSymbolReference'
    tickLineSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSpatialMapSeries(CIMMapSeries):
    """
      Spatial Map Series is a means to create a series of map pages based 
      /// off of spatial features.
    """
    indexLayerURI = str()
    nameField = str()
    numberField = str()
    categoryField = str()
    rotationField = str()
    sortField = str()
    scaleField = str()
    spatialReferenceField = str()
    sortAscending = True
    scaleRounding = 0.0
    extentOptions = ExtentFitType.BestFit
    marginType = UnitType.Percent
    marginUnits = str()
    margin = 0.0
    clipMapToIndexFeature = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTMElevationGuideBarElement(CIMMapSurround):
    """
      Represents TM Elevation Guide Bar surround element.
    """
    updateDynamically = False
    elevationBandLayerURI = str()
    numberOfBands = 4
    textSymbol = 'CIMSymbolReference'
    lineSymbol = 'CIMSymbolReference'
    highestBandSymbol = 'CIMSymbolReference'
    highBandSymbol = 'CIMSymbolReference'
    mediumBandSymbol = 'CIMSymbolReference'
    lowBandSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTabGridLine(CIMGridLine):
    """
      Defines a tab for a MapGrid.
    """
    alternatingSymbols = False
    alternatingSymbol = 'CIMSymbolReference'
    height = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableFrame(CIMMapSurround):
    """
      Layout element used to display tabular data.
    """
    fields = []
    mapMemberURI = str()
    fillingStrategy = TableFrameFillingStrategy.ShowAllRows
    fittingStrategy = TableFrameFittingStrategy.AdjustSize
    columns = 1
    minFontSize = 0
    verticalTextGap = 2
    horizontalTextGap = 2
    headingGap = 2
    rowGap = 2
    fieldGap = 2
    columnGap = 2
    headingBackgroundSymbol = 'CIMSymbolReference'
    headingBorderSymbol = 'CIMSymbolReference'
    headingLineSymbol = 'CIMSymbolReference'
    columnBorderSymbol = 'CIMSymbolReference'
    alternate1RowBackgroundSymbol = 'CIMSymbolReference'
    alternate1RowBackgroundCount = 0
    alternate2RowBackgroundSymbol = 'CIMSymbolReference'
    alternate2RowBackgroundCount = 0
    rowBorderSymbol = 'CIMSymbolReference'
    customWhereClause = str()
    defaultTableFrameField = 'CIMTableFrameField'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableFrameField(CIMTableField):
    """
      Display properties for fields in a table frame.
    """
    enableWordWrapping = False
    headingTextSymbol = 'CIMSymbolReference'
    textSymbol = 'CIMSymbolReference'
    backgroundSymbol = 'CIMSymbolReference'
    borderSymbol = 'CIMSymbolReference'
    verticalLineSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTemporalMapSeries(CIMMapSeries):
    """
      Temporal map series is a means to create a series of map pages 
      based on time settings.
    """
    timeExtent = TimeExtent
    interval = 0.0
    intervalUnits = esriTimeUnits.esriTimeUnitsMilliseconds
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTopoNorthArrow(CIMNorthArrow):
    """
      Represents a topographic north arrow which displays declination 
      of true, grid and magnetic north.
    """
    date = GetPythonClass('datetime', 'datetime')
    zone = GetPythonClass('arcpy', 'SpatialReference')
    isPrimaryZone = True
    gMAngle = 'CIMDeclination'
    gridConvergence = 'CIMDeclination'
    directionalNotes = True
    leadingZero = True
    roundGMAngle = True
    roundMils = True
    autoUpdate = True
    largeSize = True
    topographicType = TopoNorthArrowType.TLM
    textSymbol = 'CIMSymbolReference'
    lineSymbol = 'CIMSymbolReference'
    trueNorthMarkerSymbol = 'CIMSymbolReference'
    magneticNorthNegativeSymbol = 'CIMSymbolReference'
    magneticNorthPositiveSymbol = 'CIMSymbolReference'
    magneticNorthZeroSymbol = 'CIMSymbolReference'
    declinationArcSymbol = 'CIMSymbolReference'
    productSpecification = MapProductSpecType.TLM
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVerticalLegendItem(CIMLegendItem):
    """
      Represents a vertical legend item in a legend.
    """
    arrangement = LegendItemArrangement.PatchLabelDescription
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAttachmentFrame(CIMFrameElement):
    """
      Represents an attachment graphic frame.
    """
    maxImages = 1
    sortFieldName = str()
    sortOrder = FieldSortInfo.Desc
    imageFrame = 'CIMGraphicFrame'
    gridRows = 1
    gridColumns = 1
    gridRowDirection = True
    imageHeight = 1.0
    imageWidth = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAviationNorthArrow(CIMNorthArrow):
    """
      Represents a aviation north arrow which displays declination of 
      true, grid and magnetic north.
    """
    date = GetPythonClass('datetime', 'datetime')
    declinationSpatialReference = GetPythonClass('arcpy', 'SpatialReference')
    gMAngle = 'CIMDeclination'
    gridConvergence = 'CIMDeclination'
    trueNorthArrow = 'CIMAviationArrow'
    magneticNorthArrow = 'CIMAviationArrow'
    gridNorthArrow = 'CIMAviationArrow'
    variation = 'CIMAviationVariation'
    rateOfChangeTextSymbol = 'CIMSymbolReference'
    displayVariationDate = False
    displayRateOfChange = True
    autoUpdate = True
    rateOfChangeText = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAviationVerticalScaleBar(CIMFrameElement):
    """
      Represents an aviation-specific Vertical Scale Bar.
    """
    verticalLineSymbol = 'CIMSymbolReference'
    feetScale = 'CIMAviationVerticalScaleProperties'
    meterScale = 'CIMAviationVerticalScaleProperties'
    divisionMarkHeight = 5.0
    divisionsBeforeZero = False
    feetOnRight = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartFrame(CIMMapSurround):
    """
      Layout element used to display a chart.
    """
    mapMemberURI = str()
    chartName = str()
    isDynamic = True
    useMapSeriesShape = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCondensedTabGridLine(CIMTabGridLine):
    """
      Defines a condensed tab.
    """
    width = 1.0
    condensedTab = CondensedTabType.Rectangle
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMContiguousTabGridLine(CIMTabGridLine):
    """
      Defines a contiguous tab for a referenced grid.
    """
    contiguousTab = ContiguousTabType.Continuous
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCruisingAltitudeDiagram(CIMFrameElement):
    """
      Represents a Cruising Altitude Diagram.
    """
    diagramType = CruisingAltitudeDiagramType.Vertical
    altitudeTextSymbol = 'CIMSymbolReference'
    bearingTextSymbol = 'CIMSymbolReference'
    titleTextSymbol = 'CIMSymbolReference'
    bearingArrowLineSymbol = 'CIMSymbolReference'
    lineSymbol = 'CIMSymbolReference'
    diameterUnits = str()
    diagramDiameter = 0.9
    diagramTitle = str()
    verticalLeftText = str()
    verticalRightText = str()
    horizontalTopText = str()
    horizontalBottomText = str()
    quadrantalTopLeftText = str()
    quadrantalTopRightText = str()
    quadrantalBottomLeftText = str()
    quadrantalBottomRightText = str()
    autoResizeText = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDoubleFillScaleBar(CIMScaleBar):
    """
      Represents a double filled alternating scale bar.
    """
    fillSymbol1 = 'CIMSymbolReference'
    fillSymbol2 = 'CIMSymbolReference'
    style = DoubleFillScaleBarStyle.Hollow
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupFooter(CIMReportSectionElement):
    """
      Represents a group footer section in a report.
    """
    field = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupHeader(CIMReportSectionElement):
    """
      Represents a group header section in a report.
    """
    field = str()
    repeatOnEveryPage = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLegend(CIMMapSurround):
    """
      Represents a legend on a layout.
    """
    autoAdd = True
    autoFonts = False
    autoReorder = True
    autoVisibility = True
    defaultPatchHeight = 12.0
    defaultPatchWidth = 24.0
    descriptionWidth = 0.0
    groupGap = 5.0
    headingGap = 5.0
    horizontalItemGap = 5.0
    horizontalPatchGap = 5.0
    items = []
    labelWidth = 0.0
    minFontSize = 4.0
    rightToLeft = False
    scaleSymbols = False
    showTitle = True
    textGap = 5.0
    title = str()
    titleGap = 8.0
    titleSymbol = 'CIMSymbolReference'
    verticalItemGap = 5.0
    verticalPatchGap = 5.0
    layerNameGap = 5.0
    featureCountPrefix = str()
    featureCountSuffix = str()
    fittingStrategy = LegendFittingStrategy.AdjustColumnsAndSize
    groupLayerNameGap = 5.0
    columns = 1
    makeColumnsSameWidth = False
    defaultLegendItem = 'CIMLegendItem'
    excludedLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerNorthArrow(CIMNorthArrow):
    """
      Represents a marker north arrow on a page layout.
    """
    pointSymbol = 'CIMSymbolReference'
    northType = NorthType.TrueNorth
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRelatedReportSection(CIMReportSectionElement):
    """
      Represents a Related Report section of a report.
    """
    dataSource = 'CIMReportDataSource'
    relateName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportDetails(CIMReportSectionElement):
    """
      Represents a details section of a report.
    """
    columns = 1
    rowBackgroundColors = []
    rowBackgroundCount = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportFooter(CIMReportSectionElement):
    """
      Represents a report footer in a report.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportHeader(CIMReportSectionElement):
    """
      Represents a report header section in a report.
    """
    coverPage = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportPageFooter(CIMReportSectionElement):
    """
      Represents a page footer in a report.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportPageHeader(CIMReportSectionElement):
    """
      Represents a page header section in a report.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportPageSection(CIMReportSectionElement):
    """
      Represents a supplemental page section of a report.
    """
    includePageNumber = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportSection(CIMReportSectionElement):
    """
      Gets or sets the data source for a report.
    """
    dataSource = 'CIMReportDataSource'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReportLayoutPageSection(CIMReportPageSection):
    """
      Represents a layout supplemental page section of a report.
    """
    layoutURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
