﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMNumberFormat():
    """
      Represents a number format.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCurrencyFormat(CIMNumberFormat):
    """
      Represents a currency format.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCustomNumberFormat(CIMNumberFormat):
    """
      Represents a custom number format.
    """
    formatString = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDateFormat(CIMNumberFormat):
    """
      Represents a standard date and time format.
        ///  https://docs.microsoft.com/en-us/dotnet/standard/base-types/standard-date-and-time-format-strings.
    """
    format = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDirectionFormat(CIMNumberFormat):
    """
      Represents a direction format.
    """
    decimalPlaces = 3
    format = DirectionFormatOption.DegreesMinutesSeconds
    directionType = DirectionType.NorthAzimuth
    units = DirectionUnits.Radians
    useNegativeAngles = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFractionFormat(CIMNumberFormat):
    """
      Represents a fraction format.
    """
    option = FractionOption.Digits
    factor = 1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNumericFormatBase(CIMNumberFormat):
    """
      Represents the numeric format base class.
    """
    alignmentOption = esriNumericAlignmentEnum.esriAlignLeft
    alignmentWidth = 12
    roundingOption = esriRoundingOptionEnum.esriRoundNumberOfDecimals
    roundingValue = 6
    showPlusSign = False
    useSeparator = False
    zeroPad = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPercentageFormat(CIMNumericFormatBase):
    """
      Represents a percentage format.
    """
    adjustPercentage = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRateFormat(CIMNumericFormatBase):
    """
      Represents a rate format.
    """
    factor = 1.0
    label = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScientificNumberFormat(CIMNumberFormat):
    """
      Represents scientific number format.
    """
    decimalPlaces = 2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAngleFormat(CIMNumericFormatBase):
    """
      Represents an angle format.
    """
    angleInDegrees = True
    displayDegrees = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLatLonFormat(CIMNumericFormatBase):
    """
      Represents a latitude and longitude format.
    """
    showDirections = True
    isLatitude = False
    showZeroMinutes = False
    showZeroSeconds = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNumericFormat(CIMNumericFormatBase):
    """
      Represents a numeric format.
    """
    suffix = str()
    def __init__(self, *args, **Kwargs):
        pass
    
