﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIM3DMarkerGraphic():
    """
      Represents a 3D marker graphic.
    """
    primitiveType = PrimitiveType3D.TriangleStrip
    diffuseColor = 'CIMColor'
    shapeVerticesCollectionIndex = 0
    isSubstitutionAllowed = True
    materialProperties = 'CIMMaterialProperties'
    entityID = -1
    offsetIntoShapeVertices = 0
    countOfShapeVertices = 0
    patchPriority = -1
    textureIndex = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIM3DMarkerLOD():
    """
      Represents a 3D Marker LOD.
    """
    markerGraphics = []
    entityNames = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIM3DSymbolProperties():
    """
      Represents 3D symbol properties, a collection of symbol properties 
      that apply when the symbol is used in a 3D context.
    """
    dominantSizeAxis3D = DominantSizeAxis.Z
    rotationOrder3D = RotationOrder.YXZ
    scaleZ = 1.0
    scaleY = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAnimatedSymbolProperties():
    """
      Represents animated symbol properties, a collection of symbol properties 
      that apply when the symbol layer has animation data.
    """
    playAnimation = False
    reverseAnimation = False
    randomizeStartTime = False
    randomizeStartSeed = 0
    startTimeOffset = 0
    duration = 3.0
    endingDuration = 3.0
    useEndingDuration = False
    repeatType = AnimatedSymbolRepeatType.Loop
    repeatDelay = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCGAAttribute():
    """
      Represents a CGA attribute, the symbol attribute as specified by 
      the CGA code in the rule package.
    """
    name = str()
    cGAAttributeType = CGAAttributeType.Float
    value = object()
    values = list()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCallout():
    """
      Represents a callout.
    """
    leaderTolerance = 0
    leaderOffset = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartPart():
    """
      Represents a chart part, individual components of the chart marker.
    """
    value = 0.0
    polygonSymbol = 'CIMPolygonSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMClippingPath():
    """
      Represents a vector marker clipping path.
    """
    clippingType = ClippingType.Intersect
    path = GetPythonClass('arcpy', 'Polygon')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorSubstitution():
    """
      Represents color substitution, an ordered list of color substitutes.
    """
    oldColor = 'CIMColor'
    newColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCompositeTextPartPosition():
    """
      Represents the text part position properties on a callout part.
    """
    horizontalAlignment = HorizontalAlignment.Center
    verticalAlignment = VerticalAlignment.Bottom
    xOffset = 0.0
    yOffset = 0.0
    splitOffset = 0.0
    isPartWithinCalloutBox = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFontVariation():
    """
      Represents a font variation tag name and value. This is sometimes 
      referred to as a variation-axis tag and variation-axis value.
    """
    tagName = str()
    value = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffect():
    """
      Represents a geometric effect, this is base class for all geometric 
      effects.
    """
    primitiveName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerGraphic():
    """
      Represents a marker graphic which is used to define vector graphics 
      in a vector marker.
    """
    geometry = GetPythonClass('arcpy', 'Geometry')
    symbol = 'CIMSymbol'
    textString = str()
    primitiveName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacement():
    """
      Represents a marker placement.
    """
    primitiveName = str()
    placePerPart = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaterialProperties():
    """
      Represents material properties.
    """
    specularColor = 'CIMColor'
    shininess = 0.0
    externalColorMixMode = ExternalColorMixMode.Multiply
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObjectMarker3DLOD():
    """
      Represents a level of detail of an object marker 3D.
    """
    faceCount = 0
    modelURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMShapeVertex():
    """
      Represents a shape vertex.
    """
    position = GetPythonClass('arcpy', 'Point')
    normalVector = GetPythonClass('arcpy', 'Point')
    textureCoordinate = GetPythonClass('arcpy', 'Point')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMShapeVertices():
    """
      Represents shape vertices.
    """
    indices = 0
    shapes = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbol():
    """
      Represents a symbol. A symbol is used to describe how a geometric 
      shape, such as that from a graphic or feature, is displayed.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayer():
    """
      Represents a symbol layer. Symbol layers are the components that 
      make up a symbol. A symbol layer is represented by a stroke, fill, 
      marker, or procedural symbol layer.
    """
    effects = []
    enable = True
    name = str()
    colorLocked = False
    primitiveName = str()
    overprint = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTextMargin():
    """
      Represents a text margin which defines the margin to apply around 
      text.
    """
    left = 5.0
    right = 5.0
    top = 5.0
    bottom = 5.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBalloonCallout(CIMCallout):
    """
      Represents a balloon callout. Balloon callouts are a filled background 
      that is placed behind text. They may or may not have a leader line 
      connecting the callout to an anchor point.
    """
    balloonStyle = BalloonCalloutStyle.Rectangle
    backgroundSymbol = 'CIMPolygonSymbol'
    margin = 'CIMTextMargin'
    useFixedDartWidth = False
    fixedDartWidth = 7.0
    useDartSymbol = False
    dartSymbol = 'CIMPolygonSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCompositeCallout(CIMCallout):
    """
      Represents a composite callout. Composite callouts are a filled 
      background along with an optional shadow, which is placed
  /// 
      behind text. They may also have a leader line (consisting of one 
      or both of a simple line, and filled dart)
  /// connecting the 
      callout to an anchor point. Composite callouts may have additional 
      surrounding text elements.
  /// The text representing these parts 
      is specified in the text string using tags. Their relative position 
      properties are
  /// specified in the CIMCompositeCallout through 
      their corresponding CIMCompositeTextPartPosition elements specified 
      below,
  /// but these properties can also be overridden with tag 
      attributes.
    """
    cornerRadius = 5.0
    backgroundSymbol = 'CIMPolygonSymbol'
    margin = 'CIMTextMargin'
    dartWidth = 7.0
    dartSymbol = 'CIMPolygonSymbol'
    snapLeaderToCornersOnly = False
    leaderLinePercentage = 70.0
    leaderLineSymbol = 'CIMLineSymbol'
    shadowSymbol = 'CIMPolygonSymbol'
    shadowXOffset = 0.0
    shadowYOffset = 0.0
    middle = 'CIMCompositeTextPartPosition'
    topLeft = 'CIMCompositeTextPartPosition'
    top = 'CIMCompositeTextPartPosition'
    topRight = 'CIMCompositeTextPartPosition'
    right = 'CIMCompositeTextPartPosition'
    left = 'CIMCompositeTextPartPosition'
    bottomLeft = 'CIMCompositeTextPartPosition'
    bottom = 'CIMCompositeTextPartPosition'
    bottomRight = 'CIMCompositeTextPartPosition'
    floating = 'CIMCompositeTextPartPosition'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFill(CIMSymbolLayer):
    """
      Represents a fill which defines how the polygonal geometry is drawn.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectAddControlPoints(CIMGeometricEffect):
    """
      Represents the add control points geometric effect.
    """
    angleTolerance = 120.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectArrow(CIMGeometricEffect):
    """
      Represents the arrow geometric effect which creates a dynamic line 
      along a line feature with an arrow of a specified arrow type and 
      width.
    """
    arrowType = GeometricEffectArrowType.OpenEnded
    width = 5.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectBuffer(CIMGeometricEffect):
    """
      Represents the buffer geometric effect which creates a dynamic 
      polygon with a specified distance around features.
    """
    size = 1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectCircularSector(CIMGeometricEffect):
    """
      Represents the circular sector geometric effect which creates a 
      circular sector of a specified radius and start/end angles originating 
      from a point feature.
    """
    startAngle = 0
    endAngle = 45
    radius = 25
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectControlMeasureLine(CIMGeometricEffect):
    """
      Represents the control measure line geometric effect.
    """
    rule = GeometricEffectControlMeasureLineRule.FullGeometry
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectCut(CIMGeometricEffect):
    """
      Represents the cut geometric effect which creates a dynamic line 
      that is shorter on one or both ends than the line feature or polygon 
      outline.
    """
    beginCut = 1
    endCut = 1
    middleCut = 0
    invert = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectDashes(CIMGeometricEffect):
    """
      Represents the dashes geometric effect which creates a dynamic 
      multipart line geometry from a line feature or the outline of a 
      polygon based on a template.
    """
    customEndingOffset = 0.0
    dashTemplate = []
    lineDashEnding = LineDashEnding.NoConstraint
    offsetAlongLine = 0
    controlPointEnding = LineDashEnding.NoConstraint
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectDonut(CIMGeometricEffect):
    """
      Represents the donut geometric effect which creates a dynamic polygon 
      ring of a specified width in relation to the outline of polygon 
      features.
    """
    method = GeometricEffectDonutMethod.Mitered
    option = GeometricEffectOffsetOption.Accurate
    width = 2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectEnclosingPolygon(CIMGeometricEffect):
    """
      Represents the enclosing polygon geometric effect which creates 
      a dynamic polygon from the spatial extent of a line or polygon 
      feature.
    """
    method = GeometricEffectEnclosingPolygonMethod.RectangularBox
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectExtension(CIMGeometricEffect):
    """
      Represents the extension geometric effect which creates a dynamic 
      line that is extended from either the beginning or the end of the 
      line feature at a specified deflection angle and length.
    """
    deflection = 45
    origin = GeometricEffectExtensionOrigin.EndOfLine
    length = 5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectJog(CIMGeometricEffect):
    """
      Represents the jog geometric effect which creates a dynamic line 
      with a jog of a specified angle, position, and width in the line.
    """
    angle = 225.0
    length = 20.0
    position = 50.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectLocalizerFeather(CIMGeometricEffect):
    """
      Represents a geometric effect which creates a localizer feather 
      for aeronautical charts.
    """
    style = GeometricEffectLocalizerFeatherStyle.Complete
    length = 50
    width = 6
    angle = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectMove(CIMGeometricEffect):
    """
      Represents the move geometric effect which creates a point, line 
      or polygon that is offset a specified distance in X and Y.
    """
    offsetX = 1
    offsetY = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectOffset(CIMGeometricEffect):
    """
      Represents the offset geometric effect which creates a dynamic 
      line or polygon offset at a specified distance perpendicularly 
      from a feature.
    """
    method = GeometricEffectOffsetMethod.Square
    offset = 1
    option = GeometricEffectOffsetOption.Fast
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectOffsetHatch(CIMGeometricEffect):
    """
      Represents a geometric effect which creates a hatch pattern to 
      depict special use airspace for aeronautical charts.
    """
    length = 5
    spacing = 2.5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectOffsetTangent(CIMGeometricEffect):
    """
      Represents the offset tangent geometric effect which creates a 
      dynamic line along a line feature offset in the direction defined 
      by either the beginning or the end of the line.
    """
    method = GeometricEffectOffsetTangentMethod.BeginningOfLine
    offset = 5.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectRadial(CIMGeometricEffect):
    """
      Represents the radial geometric effect which creates a dynamic 
      line of a specified length and angle originating from a point feature.
    """
    angle = 0
    length = 5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectRegularPolygon(CIMGeometricEffect):
    """
      Represents the regular polygon geometric effect which creates a 
      dynamic polygon around a point feature with a specified number 
      of edges. All edges are equal in length and all angles are equal.
    """
    angle = 0
    edges = 4
    radius = 2.5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectReverse(CIMGeometricEffect):
    """
      Represents the reverse geometric effect which creates a dynamic 
      polygon around a point feature with a specified number of edges. 
      All edges are equal in length and all angles are equal.
    """
    reverse = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectRotate(CIMGeometricEffect):
    """
      Represents the rotate geometric effect which creates a dynamic 
      line or polygon rotated a specified angle from the feature.
    """
    angle = 15
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectScale(CIMGeometricEffect):
    """
      Represents the rotate geometric effect which creates a dynamic 
      line or polygon scaled by a specified factor. Vertices are moved 
      in relation to the center point of a feature envelope. Values greater 
      than 1 move vertices away from the center point. Values between 
      0 and 1 move vertices toward the center point. Values less than 
      0 draw an inverse dynamic line or polygon where the vertices have 
      crossed to the other side of the center point.
    """
    xScaleFactor = 1.15
    yScaleFactor = 1.15
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectSuppress(CIMGeometricEffect):
    """
      Represents the suppress geometric effect which creates a dynamic 
      line that hides sections of a stroke between pairs control points.
    """
    suppress = True
    invert = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectTaperedPolygon(CIMGeometricEffect):
    """
      Represents the tapered polygon geometric effect which creates a 
      dynamic polygon along a line feature, whose width varies by two 
      specified amounts along its length, as defined by a percentage 
      of the line feature's length.
    """
    fromWidth = 0
    length = 0
    toWidth = 1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometricEffectWave(CIMGeometricEffect):
    """
      Represents the wave geometric effect which creates a dynamic line 
      or polygon along a feature with a repeating wave pattern.
    """
    amplitude = 2
    period = 3
    seed = 1
    waveform = GeometricEffectWaveform.Sinus
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGradientFill(CIMFill):
    """
      Represents a gradient fill which fills polygonal geometry with 
      a specified color scheme.
    """
    angle = 90
    colorRamp = 'CIMColorRamp'
    gradientMethod = GradientFillMethod.Linear
    gradientSize = 75.0
    gradientSizeUnits = SymbolUnits.Relative
    gradientType = GradientStrokeType.Discrete
    interval = 5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHatchFill(CIMFill):
    """
      Represents a hatch fill which fills polygonal geometry with a uniform 
      series of parallel line symbols.
    """
    lineSymbol = 'CIMLineSymbol'
    offsetX = 0
    rotation = 0
    separation = 4
    offsetY = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLineCallout(CIMCallout):
    """
      Represents a line callout.
    """
    leaderLineSymbol = 'CIMLineSymbol'
    gap = 0
    lineStyle = LeaderLineStyle.Base
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarker(CIMSymbolLayer):
    """
      Represents a marker which is a self-contained shape or image that 
      can draw for a point graphic or placed in a repeating arrangement 
      along a stroke or within a fill. It can be a glyph from a font, 
      a picture, a collection of vector geometries, or a 3D model.
    """
    anchorPoint = GetPythonClass('arcpy', 'Point')
    anchorPointUnits = SymbolUnits.Relative
    angleX = 0.0
    angleY = 0.0
    dominantSizeAxis3D = DominantSizeAxis.Z
    offsetX = 0.0
    offsetY = 0.0
    offsetZ = 0.0
    rotateClockwise = False
    rotation = 0.0
    size = 10.0
    billboardMode3D = BillboardMode.FaceNearPlane
    markerPlacement = 'CIMMarkerPlacement'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarker3D(CIMMarker):
    """
      Represents a 3D marker which consists of one or more ShapeGraphics 
      contained within one or more ShapeLODs.
    """
    lODLevels = []
    lODDistances = []
    width = 10.0
    depth = 1.0
    color = 'CIMColor'
    isRestricted = False
    shapeVertices = []
    textures = []
    thumbnail = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerFillPlacement(CIMMarkerPlacement):
    """
      Represents a marker fill placement.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAroundPolygon(CIMMarkerFillPlacement):
    """
      Represents marker placement around polygon which places a marker 
      on a specific position on the polygon outline.
    """
    position = PlacementAroundPolygonPosition.Top
    offset = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementInsidePolygon(CIMMarkerFillPlacement):
    """
      Represents marker placement inside a polygon which defines how 
      a polygon is filled with a pattern of markers.
    """
    gridAngle = 0
    gridType = PlacementGridType.Fixed
    offsetX = 0
    randomness = 100
    seed = 0
    shiftOddRows = False
    stepX = 16
    stepY = 16
    offsetY = 0
    clipping = PlacementClip.ClipAtBoundary
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementPolygonCenter(CIMMarkerFillPlacement):
    """
      Represents marker placement polygon center which defines how a 
      single marker will be placed within the polygon.
    """
    method = PlacementPolygonCenterMethod.OnPolygon
    offsetX = 0
    offsetY = 0
    clipAtBoundary = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerStrokePlacement(CIMMarkerPlacement):
    """
      Represents a marker stroke placement.
    """
    angleToLine = True
    offset = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaterialSymbolLayer(CIMSymbolLayer):
    """
      Represents a material which defines how the multipatch or mesh 
      is drawn.
    """
    color = 'CIMColor'
    materialMode = MaterialMode.Multiply
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMeshEdge(CIMSymbolLayer):
    """
      Represents a stroke drawn at specified edges of a mesh.
    """
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultiLayerSymbol(CIMSymbol):
    """
      Represents a multilayer symbol, a generic type for point, line, 
      and polygon symbols, specifying that they can contain more than 
      one symbol layers.
    """
    effects = []
    symbolLayers = []
    thumbnailURI = str()
    useRealWorldSymbolSizes = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObjectMarker3D(CIMMarker):
    """
      Represents a marker symbol for 3D objects.
    """
    modelURI = str()
    width = 10.0
    depth = 1.0
    tintColor = 'CIMColor'
    isRestricted = False
    thumbnail = str()
    useAnchorPoint = True
    lODs = []
    primitiveShapeType = PrimitiveShapeType.Unknown
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPictureFill(CIMFill):
    """
      Represents a picture fill which fills polygonal geometry with a 
      picture. Supported file types are .bmp, .jpg, .png, and .gif.
    """
    url = str()
    offsetX = 0
    offsetY = 0
    rotation = 0
    scaleX = 1
    height = 10
    textureFilter = TextureFilter.Draft
    colorSubstitutions = []
    tintColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPictureMarker(CIMMarker):
    """
      Represents a picture marker created from a raster (bitmapped) image 
      file. The image can have color substitutions to replace one or 
      more colors in the image or it can have a tint applied to the whole 
      image depending on the picture type. Supported formats are .bmp, 
      .jpg, .png, and .gif.
    """
    colorSubstitutions = []
    depth3D = 0.0
    invertBackfaceTexture = True
    scaleX = 1.0
    textureFilter = TextureFilter.Draft
    tintColor = 'CIMColor'
    url = str()
    verticalOrientation3D = False
    animatedSymbolProperties = 'CIMAnimatedSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointSymbol(CIMMultiLayerSymbol):
    """
      Represents a point symbol used to draw point features and point 
      graphics.
    """
    callout = 'CIMCallout'
    haloSize = 1.0
    haloSymbol = 'CIMPolygonSymbol'
    primitiveName = str()
    scaleX = 1
    symbol3DProperties = 'CIM3DSymbolProperties'
    angle = 0.0
    angleAlignment = AngleAlignment.Display
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointSymbolCallout(CIMLineCallout):
    """
      Represents a point symbol callout which draws a point symbol as 
      the background and a line symbol for leaders. Often used for highway 
      shields.
    """
    pointSymbol = 'CIMPointSymbol'
    backgroundScale = PointSymbolCalloutScale.eNone
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPolygonSymbol(CIMMultiLayerSymbol):
    """
      Represents a polygon symbol which is used to draw polygon features 
      or polygon graphics.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProceduralSymbolLayer(CIMSymbolLayer):
    """
      Represents a procedural symbol layer which defines rendering using 
      script-based logic to construct complex 3D objects and textures 
      from simple geometries. Properties of the symbol are derived from 
      a rule package (.rpk file).
    """
    attributes = []
    rulePackage = str()
    rulePackageName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSimpleLineCallout(CIMCallout):
    """
      Represents a simple line callout for drawing basic leader lines.
    """
    lineSymbol = 'CIMLineSymbol'
    autoSnap = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSolidFill(CIMFill):
    """
      Represents a solid fill which fills polygonal geometry with a single 
      solid color.
    """
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSolidMeshEdge(CIMMeshEdge):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStroke(CIMSymbolLayer):
    """
      Represents a stroke which defines how line geometry or the outline 
      of polygon geometry is drawn.
    """
    capStyle = LineCapStyle.Round
    joinStyle = LineJoinStyle.Round
    lineStyle3D = Simple3DLineStyle.Strip
    miterLimit = 4.0
    width = 4
    closeCaps3D = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTextSymbol(CIMSymbol):
    """
      Represents a text symbol which is used to draw text graphics, bleeds, 
      and annotation. Text symbols do not contain any symbol layers but 
      can have callouts.
    """
    angle = 0.0
    angleX = 0.0
    angleY = 0.0
    blockProgression = BlockProgression.TTB
    callout = 'CIMCallout'
    compatibilityMode = False
    countryISO = str()
    depth3D = 1.0
    drawGlyphsAsGeometry = False
    drawSoftHyphen = False
    extrapolateBaselines = True
    flipAngle = 0.0
    fontEffects = FontEffects.Normal
    fontEncoding = FontEncoding.Unicode
    fontFamilyName = str()
    fontStyleName = str()
    fontType = FontType.Unspecified
    fontVariationSettings = []
    glyphRotation = 0.0
    haloSize = 1.0
    haloSymbol = 'CIMPolygonSymbol'
    height = 10.0
    hinting = GlyphHinting.Default
    horizontalAlignment = HorizontalAlignment.Left
    indentAfter = 0.0
    indentBefore = 0.0
    indentFirstLine = 0.0
    kerning = True
    languageISO = str()
    letterSpacing = 0.0
    letterWidth = 100.0
    ligatures = True
    lineGap = 0.0
    lineGapType = LineGapType.ExtraLeading
    offsetX = 0.0
    offsetY = 0.0
    offsetZ = 0.0
    shadowColor = 'CIMColor'
    shadowOffsetX = 0.0
    shadowOffsetY = 0.0
    smallCaps = False
    strikethrough = False
    symbol = 'CIMPolygonSymbol'
    symbol3DProperties = 'CIM3DSymbolProperties'
    textCase = TextCase.Normal
    textDirection = TextReadingDirection.LTR
    underline = False
    verticalAlignment = VerticalAlignment.Bottom
    verticalGlyphOrientation = VerticalGlyphOrientation.Right
    wordSpacing = 100.0
    billboardMode3D = BillboardMode.FaceNearPlane
    overprint = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVectorMarker(CIMMarker):
    """
      Represents a vector marker which can represent vector graphics. 
      It's constructed from MarkerGraphics which are geometries and symbols 
      used as building blocks for the marker.
    """
    depth3D = 0.0
    frame = GetPythonClass('arcpy', 'Extent')
    markerGraphics = []
    verticalOrientation3D = False
    scaleSymbolsProportionally = False
    respectFrame = True
    clippingPath = 'CIMClippingPath'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWaterFill(CIMFill):
    """
      Represents a water fill which fills polygonal geometry with animated 
      water.
    """
    color = 'CIMColor'
    waveStrength = WaveStrength.Rippled
    waterbodySize = WaterbodySize.Medium
    waveHasDirection = False
    waveDirection = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMglTFMarker3D(CIMMarker):
    """
      Represents a marker symbol for 3D objects.
    """
    modelURI = str()
    additionalModelURIs = []
    width = 10.0
    depth = 1.0
    tintColor = 'CIMColor'
    isRestricted = False
    thumbnail = str()
    useAnchorPoint = True
    animatedSymbolProperties = 'CIMAnimatedSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBackgroundCallout(CIMLineCallout):
    """
      Represents a background callout which draws a callout with an optional 
      polygon background and leader line.
    """
    backgroundSymbol = 'CIMPolygonSymbol'
    accentBarSymbol = 'CIMLineSymbol'
    margin = 'CIMTextMargin'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCharacterMarker(CIMMarker):
    """
      Represents a character marker.
    """
    characterIndex = 33
    depth3D = 0.0
    fontFamilyName = str()
    fontStyleName = str()
    fontType = FontType.Unspecified
    fontVariationSettings = []
    scaleX = 1.0
    symbol = 'CIMPolygonSymbol'
    verticalOrientation3D = False
    scaleSymbolsProportionally = False
    respectFrame = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartMarker(CIMMarker):
    """
      Represents a chart marker, a marker used to display a chart.
    """
    display3D = False
    parts = []
    thickness3D = 3.0
    tilt3D = 45.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGradientStroke(CIMStroke):
    """
      Represents a gradient stroke which draws linear geometry with a 
      specified color scheme.
    """
    colorRamp = 'CIMColorRamp'
    gradientMethod = GradientStrokeMethod.AcrossLine
    gradientSize = 75.0
    gradientSizeUnits = SymbolUnits.Relative
    gradientType = GradientStrokeType.Discrete
    interval = 5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLineSymbol(CIMMultiLayerSymbol):
    """
      Represents a line symbol which is used to draw polyline features 
      or graphics.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAlongLine(CIMMarkerStrokePlacement):
    """
      Represents marker placement along the line which defines how a 
      marker is placed along a line or polygon outline.
    """
    controlPointPlacement = PlacementEndings.WithHalfGap
    customEndingOffset = 0.0
    endings = PlacementEndings.WithHalfGap
    offsetAlongLine = 0.0
    placementTemplate = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAlongLineRandomSize(CIMMarkerPlacementAlongLine):
    """
      Represents marker placement along the line which places randomly 
      sized markers evenly along a line or polygon outline.
    """
    randomization = PlacementRandomlyAlongLineRandomization.Low
    seed = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAlongLineSameSize(CIMMarkerPlacementAlongLine):
    """
      Represents marker placement along the line which places markers 
      that are the same size evenly along a line or polygon outline.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAlongLineVariableSize(CIMMarkerPlacementAlongLine):
    """
      Represents marker placement along the line which places markers 
      in either increasing, decreasing or alternating gradations along 
      a line or polygon outline.
    """
    maxRandomOffset = 0
    maxZoom = 1.5
    minZoom = 0.5
    numberOfSizes = 3
    seed = 0
    variationMethod = SizeVariationMethod.Random
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAtExtremities(CIMMarkerStrokePlacement):
    """
      Represents marker placement at extremities which places markers 
      at only one or both endpoints of a line.
    """
    extremityPlacement = ExtremityPlacement.Both
    offsetAlongLine = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAtMeasuredUnits(CIMMarkerStrokePlacement):
    """
      Represents marker placement at geometry M values.
    """
    interval = 100
    skipMarkerRate = 0
    placeAtExtremities = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementAtRatioPositions(CIMMarkerStrokePlacement):
    """
      Represents marker placement at ratio positions which places a set 
      number of markers along the line or the outline of a polygon.
    """
    beginPosition = 0
    endPosition = 0
    flipFirst = True
    positionArray = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementOnLine(CIMMarkerStrokePlacement):
    """
      Represents a marker placement on the line.
    """
    relativeTo = PlacementOnLineRelativeTo.LineMiddle
    startPointOffset = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMarkerPlacementOnVertices(CIMMarkerStrokePlacement):
    """
      Represents a marker placement on vertices which places a single 
      marker on a line or polygon outline at a set distance from the 
      middle or one of the endpoints.
    """
    placeOnControlPoints = True
    placeOnEndPoints = True
    placeOnRegularVertices = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMeshSymbol(CIMMultiLayerSymbol):
    """
      Represents a mesh symbol which is used to draw multipatch features 
      or mesh features.
    """
    animatedSymbolProperties = 'CIMAnimatedSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPictureStroke(CIMStroke):
    """
      Represents a picture stroke which draws linear geometry with a 
      repeating image file. Supported file types are .bmp, .jpg, .png, 
      and .gif.
    """
    colorSubstitutions = []
    textureFilter = TextureFilter.Draft
    url = str()
    tintColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPieChartMarker(CIMChartMarker):
    """
      Represents a pie chart marker which is a marker that draws numeric 
      values arranged in a circle.
    """
    clockwise = False
    showOutline = False
    outlineSymbol = 'CIMLineSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSolidStroke(CIMStroke):
    """
      Represents a solid stroke which draws linear geometry with a single 
      solid color.
    """
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStackedBarChartMarker(CIMChartMarker):
    """
      Represents a stacked bar chart marker which is a chart made of 
      vertical stacked bars displaying values.
    """
    fixedLength = False
    showOutline = False
    outlineSymbol = 'CIMLineSymbol'
    verticalBar = True
    width = 8.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBarChartMarker(CIMChartMarker):
    """
      Represents a bar chart marker, a chart made of vertical bars displaying 
      values.
    """
    axesSymbol = 'CIMLineSymbol'
    spacing = 0.0
    verticalBars = True
    width = 6.0
    showAxes = False
    def __init__(self, *args, **Kwargs):
        pass
    
